(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     82514,       1977]
NotebookOptionsPosition[     77132,       1859]
NotebookOutlinePosition[     77571,       1876]
CellTagsIndexPosition[     77528,       1873]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\

SUMCON
3D Graphics Package\
\>", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.5714899059827147`*^9, 3.5714899223796525`*^9}, {
  3.5714910769176884`*^9, 
  3.5714910780057507`*^9}},ExpressionUUID->"7cdc2b97-d9d4-4461-90ec-\
a05a0f1b46d2"],

Cell[CellGroupData[{

Cell["Module", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571489929649068*^9, 
  3.5714899304721155`*^9}},ExpressionUUID->"42bc0147-c2f8-4293-b696-\
9de57ea7d513"],

Cell[CellGroupData[{

Cell["3D Graphics Generation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5114286038609667`*^9, 3.511428607027773*^9}, {
  3.567180074094695*^9, 
  3.567180096603983*^9}},ExpressionUUID->"1bdcabe1-ce5d-444b-bb42-\
718332cee99c"],

Cell[CellGroupData[{

Cell["Generate a closed cuboid", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5109958056189184`*^9, 3.5109958134353657`*^9}, {
   3.510996334486168*^9, 3.5109963376243477`*^9}, 3.510996429038576*^9, {
   3.5112274069760227`*^9, 3.511227413356434*^9}, {3.511227639104431*^9, 
   3.5112276447048407`*^9}, 
   3.5670995489347954`*^9},ExpressionUUID->"ba541816-2a95-48b3-b756-\
5a46843e8002"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myCuboid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dx_", ",", "dy_", ",", "dz_"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5109958202167535`*^9, 3.510995848426367*^9}, {
  3.510995883940398*^9, 3.5109959541894164`*^9}, {3.510996067485896*^9, 
  3.510996429038576*^9}, {3.5112274069760227`*^9, 3.511227413356434*^9}, {
  3.511227639104431*^9, 3.5112276447048407`*^9}, {3.5670995489347954`*^9, 
  3.5670995810006294`*^9}, {3.5701198021047072`*^9, 
  3.570119803113765*^9}},ExpressionUUID->"c97a2db6-efac-416f-ae1a-\
ed1f420c8650"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate an open cuboid (y-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.5109958056189184`*^9, 3.5109958134353657`*^9}, 
   3.510996424365309*^9, {3.567100215798938*^9, 
   3.5671002193521414`*^9}},ExpressionUUID->"42410490-7eb4-4554-8d00-\
d34c3a2d6dd6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myOpenCuboid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dx_", ",", "dy_", ",", "dz_"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "-", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "-", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "+", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "+", 
            RowBox[{"dx", "/", "2"}]}], ",", 
           RowBox[{"y", "-", 
            RowBox[{"dy", "/", "2"}]}], ",", 
           RowBox[{"z", "+", 
            RowBox[{"dz", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
        "}"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.5109958202167535`*^9, 3.510995848426367*^9}, {
   3.510995883940398*^9, 3.5109959541894164`*^9}, {3.510996067485896*^9, 
   3.510996320426364*^9}, 3.510996424365309*^9, {3.5670995929573135`*^9, 
   3.567099599628695*^9}, 3.567100223682389*^9, {3.570119809116108*^9, 
   3.570119810462185*^9}},ExpressionUUID->"9fedae6f-5bbe-4607-84b6-\
0452eb28fdf1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate a closed cylinder", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.9162763646240754`*^9, 3.9162763647279015`*^9}, {3.916277235629404*^9, 
   3.916277263506465*^9}},ExpressionUUID->"dcdff543-fc59-42ac-962e-\
1e8ca59988db"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myClosedCylinder", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d_", ",", " ", "l_", ",", "xv_", ",", "yv_", ",", "zv_"}], 
       "}"}]}], "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Cylinder", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "z"}], "}"}], "-", 
         RowBox[{"l", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"xv", ",", "yv", ",", "zv"}], "}"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", "*", 
              RowBox[{"N", "[", 
               RowBox[{"Norm", "[", 
                RowBox[{"{", 
                 RowBox[{"xv", ",", "yv", ",", "zv"}], "}"}], "]"}], "]"}]}], 
             ")"}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "z"}], "}"}], "+", 
         RowBox[{"l", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"xv", ",", "yv", ",", "zv"}], "}"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", "*", 
              RowBox[{"N", "[", 
               RowBox[{"Norm", "[", 
                RowBox[{"{", 
                 RowBox[{"xv", ",", "yv", ",", "zv"}], "}"}], "]"}], "]"}]}], 
             ")"}]}], ")"}]}]}]}], "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"d", "/", "2"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.5165115051288853`*^9, 
   3.5165115118680973`*^9}, {3.5670996066670976`*^9, 3.567099611396368*^9}, {
   3.56709970654181*^9, 3.567099727357001*^9}, {3.5701198148444357`*^9, 
   3.5701198159945016`*^9}, {3.9162763666900387`*^9, 3.91627636716164*^9}, {
   3.916276425306394*^9, 3.916276485425547*^9}, {3.9162772679261813`*^9, 
   3.9162773270484915`*^9}, {3.916277362804064*^9, 3.9162774970683928`*^9}, {
   3.916277536128585*^9, 3.916277594837815*^9}, {3.916278099434836*^9, 
   3.9162781033529463`*^9}, {3.916278178174353*^9, 3.9162781793345647`*^9}, {
   3.91627828993598*^9, 
   3.9162782981546435`*^9}},ExpressionUUID->"017cf960-9297-4d43-94c0-\
86cfd45c8757"],

Cell["Generate an open cylinder (x-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.9162763646240754`*^9, 3.9162763647279015`*^9}, {3.916277235629404*^9, 
   3.916277235685582*^9}},ExpressionUUID->"cc6a6b6d-898b-4a18-92fe-\
89577d1c3ff0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myCylinderX", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d_", ",", " ", "l_"}], "}"}]}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rc1", ",", "rs1", ",", "rc2", ",", "rs2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"rc1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         " ", 
         RowBox[{"rs1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rc2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", " ", 
         RowBox[{"rs2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", "\n", "\t", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", ",",
                  "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", "Red", 
             ",", "Blue"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"y", "+", "rs1"}], ",", " ", 
                RowBox[{"z", "+", "rc1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"y", "+", " ", "rs1"}], ",", 
                RowBox[{"z", "+", "rc1"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"y", "+", "rs2"}], ",", " ", 
                RowBox[{"z", "+", "rc2"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"y", "+", " ", "rs2"}], ",", 
                RowBox[{"z", "+", "rc2"}]}], "}"}]}], " ", "}"}], 
            "\[IndentingNewLine]", "]"}]}], "}"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.5165115051288853`*^9, 
   3.5165115118680973`*^9}, {3.5670996066670976`*^9, 3.567099611396368*^9}, {
   3.56709970654181*^9, 3.567099727357001*^9}, {3.5701198148444357`*^9, 
   3.5701198159945016`*^9}, {3.9162763666900387`*^9, 3.91627636716164*^9}, {
   3.916276425306394*^9, 
   3.916276485425547*^9}},ExpressionUUID->"afbacabd-baae-41f3-90b8-\
4fcbc753fae0"],

Cell["Generate an open cylinder (y-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 
   3.511151450130741*^9}},ExpressionUUID->"8d85ba5d-4778-4a33-9a67-\
fb054c9f7ae6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myCylinderY", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d_", ",", " ", "l_"}], "}"}]}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rc1", ",", "rs1", ",", "rc2", ",", "rs2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"rc1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         " ", 
         RowBox[{"rs1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rc2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", " ", 
         RowBox[{"rs2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", ",",
                  "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", "Red", 
             ",", "Blue"}], "]"}], ",", "\n", "\t", 
           RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc1"}], ",", " ", 
                RowBox[{"y", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"z", "+", "rs1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc1"}], ",", 
                RowBox[{"y", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"z", "+", " ", "rs1"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc2"}], ",", " ", 
                RowBox[{"y", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"z", "+", "rs2"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc2"}], ",", 
                RowBox[{"y", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"z", "+", " ", "rs2"}]}], "}"}]}], " ", "}"}], 
            "\[IndentingNewLine]", "]"}]}], "}"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.5165115051288853`*^9, 
   3.5165115118680973`*^9}, {3.5670996066670976`*^9, 3.567099611396368*^9}, {
   3.56709970654181*^9, 3.567099727357001*^9}, {3.5701198148444357`*^9, 
   3.5701198159945016`*^9}},ExpressionUUID->"1e6f8192-dd92-496f-abbc-\
083c354bc84e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate an open cylinder (z-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150807206812*^9}, {3.5111514323467097`*^9, 
   3.511151441113925*^9}},ExpressionUUID->"5ce5f857-7140-4107-9864-\
a807e7806106"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myCylinderZ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d_", ",", " ", "l_"}], "}"}]}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rc1", ",", "rs1", ",", "rc2", ",", "rs2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"rc1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         " ", 
         RowBox[{"rs1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rc2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", " ", 
         RowBox[{"rs2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"d", "*", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", "\n", "\t", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", ",",
                  "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", "Red", 
             ",", "Blue"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc1"}], ",", " ", 
                RowBox[{"y", "+", "rs1"}], ",", " ", 
                RowBox[{"z", "+", 
                 RowBox[{"l", "/", "2"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc1"}], ",", 
                RowBox[{"y", "+", " ", "rs1"}], ",", 
                RowBox[{"z", "-", 
                 RowBox[{"l", "/", "2"}]}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc2"}], ",", " ", 
                RowBox[{"y", "+", "rs2"}], ",", " ", 
                RowBox[{"z", "-", 
                 RowBox[{"l", "/", "2"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rc2"}], ",", 
                RowBox[{"y", "+", " ", "rs2"}], ",", 
                RowBox[{"z", "+", 
                 RowBox[{"l", "/", "2"}]}]}], "}"}]}], " ", "}"}], 
            "\[IndentingNewLine]", "]"}]}], "}"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150807206812*^9}, {3.5165106389977584`*^9, 3.5165107365447297`*^9}, {
   3.5165107868548183`*^9, 3.516510791456826*^9}, {3.5165108907510004`*^9, 
   3.5165109096114335`*^9}, {3.5165109413106894`*^9, 3.516510951185507*^9}, {
   3.516510994163582*^9, 3.516511006019603*^9}, {3.516511385882276*^9, 
   3.516511415101127*^9}, {3.5165114554895983`*^9, 3.516511462634411*^9}, {
   3.5670996163996544`*^9, 3.567099620625896*^9}, {3.5670997455900435`*^9, 
   3.5670997650811586`*^9}, {3.5701198211497965`*^9, 
   3.570119822279861*^9}},ExpressionUUID->"371e64b6-ab06-405a-98f5-\
b1b9b38f9bdb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate an open truncated cone (y-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.511227639104431*^9, 3.511227676201296*^9}, 
   3.5112278371467786`*^9},ExpressionUUID->"689d6318-543f-403b-9a0a-\
7207ad863635"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myTruncatedCone", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"du_", ",", "dl_", ",", " ", "l_"}], "}"}]}], "]"}], " ", ":=",
     "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "ruc1", ",", "rus1", ",", "ruc2", ",", "rus2", ",", "rlc1", ",", 
        "rls1", ",", "rlc2", ",", "rls2"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ruc1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"du", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         " ", 
         RowBox[{"rus1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"du", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ruc2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"du", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", " ", 
         RowBox[{"rus2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"du", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"rlc1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"dl", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         " ", 
         RowBox[{"rls1", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"dl", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rlc2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"dl", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", " ", 
         RowBox[{"rls2", "=", " ", 
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"dl", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
            "]"}], "/", "2"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", ",",
                  "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", "Red", 
             ",", "Blue"}], "]"}], ",", "\n", "\t", 
           RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "ruc1"}], ",", " ", 
                RowBox[{"y", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"z", "+", "rus1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rlc1"}], ",", 
                RowBox[{"y", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"z", "+", " ", "rls1"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "rlc2"}], ",", " ", 
                RowBox[{"y", "-", 
                 RowBox[{"l", "/", "2"}]}], ",", " ", 
                RowBox[{"z", "+", "rls2"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", "ruc2"}], ",", 
                RowBox[{"y", "+", 
                 RowBox[{"l", "/", "2"}]}], ",", 
                RowBox[{"z", "+", " ", "rus2"}]}], "}"}]}], " ", "}"}], 
            "\[IndentingNewLine]", "]"}]}], "}"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.511227639104431*^9, 
   3.511227648464447*^9}, {3.511227686902915*^9, 3.5112276902881203`*^9}, {
   3.5112277642166505`*^9, 3.511227834057973*^9}, {3.5112281336096992`*^9, 
   3.511228136370904*^9}, 3.5112282416866894`*^9, {3.5165115201361113`*^9, 
   3.5165115231001167`*^9}, {3.56709963171453*^9, 3.5670996359397717`*^9}, {
   3.5670997755387564`*^9, 3.567099800122163*^9}, {3.5671001952827644`*^9, 
   3.5671002063373966`*^9}, {3.570119827547162*^9, 
   3.570119828417212*^9}},ExpressionUUID->"2f59a05b-d63c-42ae-afa8-\
4d9e70cd4dfb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate an open double cylinder (y-oriented)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.5112274069760227`*^9, 
   3.5112274243700533`*^9}},ExpressionUUID->"2d127797-f7fe-41a9-86f8-\
1a258aadf00e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myDoubleCylinder", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"du_", ",", "dl_", ",", "hu_", ",", "hl_", ",", "hc_"}], 
       "}"}]}], "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rc1", ",", "rs1", ",", "rc2", ",", "rs2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"rc1", "=", " ", 
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"du", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", "Pi", " ", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], 
           ";", " ", 
           RowBox[{"rs1", "=", " ", 
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"du", " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", "Pi", " ", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], "]"}], "/", "2"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"rc2", "=", " ", 
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"du", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", "Pi", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
              "]"}], "/", "2"}]}], ";", " ", 
           RowBox[{"rs2", "=", " ", 
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"du", " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", "Pi", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}]}], 
              "]"}], "/", "2"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", 
                   ",", "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", 
               "Red", ",", "Blue"}], "]"}], ",", "\n", "\t", 
             RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc1"}], ",", " ", 
                  RowBox[{"y", "+", "hu", "+", "hl", "-", "hc"}], ",", " ", 
                  RowBox[{"z", "+", "rs1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc1"}], ",", 
                  RowBox[{"y", "+", "hl", "-", "hc"}], ",", 
                  RowBox[{"z", "+", " ", "rs1"}]}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc2"}], ",", " ", 
                  RowBox[{"y", "+", "hl", "-", "hc"}], ",", " ", 
                  RowBox[{"z", "+", "rs2"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc2"}], ",", 
                  RowBox[{"y", "+", "hu", "+", "hl", "-", "hc"}], ",", 
                  RowBox[{"z", "+", " ", "rs2"}]}], "}"}]}], " ", "}"}], 
              "\[IndentingNewLine]", "]"}]}], "}"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "4", ",", "5", ",", "9", ",", "10", ",", "14", ",", "15", 
                  ",", "19", ",", "20"}], "}"}], ",", "i"}], "]"}], ",", 
              "Red", ",", "Blue"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"rc1", "=", " ", 
              RowBox[{"N", "[", 
               RowBox[{"dl", " ", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"2", "Pi", " ", 
                   RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], 
             ";", " ", 
             RowBox[{"rs1", "=", " ", 
              RowBox[{"N", "[", 
               RowBox[{"dl", " ", 
                RowBox[{
                 RowBox[{"Sin", "[", 
                  RowBox[{"2", "Pi", " ", 
                   RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"rc2", "=", " ", 
              RowBox[{"N", "[", 
               RowBox[{"dl", " ", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"2", "Pi", " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/",
                  "2"}]}], "]"}]}], ";", " ", 
             RowBox[{"rs2", "=", " ", 
              RowBox[{"N", "[", 
               RowBox[{"dl", " ", 
                RowBox[{
                 RowBox[{"Sin", "[", 
                  RowBox[{"2", "Pi", " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/",
                  "2"}]}], "]"}]}], ";", "\n", "\t", 
             RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc1"}], ",", " ", 
                  RowBox[{"y", "+", "hl", "-", "hc"}], ",", " ", 
                  RowBox[{"z", "+", "rs1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc1"}], ",", 
                  RowBox[{"y", "-", "hc"}], ",", 
                  RowBox[{"z", "+", " ", "rs1"}]}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc2"}], ",", " ", 
                  RowBox[{"y", "-", "hc"}], ",", " ", 
                  RowBox[{"z", "+", "rs2"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "+", "rc2"}], ",", 
                  RowBox[{"y", "+", "hl", "-", "hc"}], ",", 
                  RowBox[{"z", "+", " ", "rs2"}]}], "}"}]}], " ", "}"}], 
              "\[IndentingNewLine]", "]"}]}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.5112274069760227`*^9, 
   3.51122748491376*^9}, {3.511227533351845*^9, 3.511227617014792*^9}, {
   3.511228468261487*^9, 3.511228501068345*^9}, {3.5112287851760435`*^9, 
   3.511228786502046*^9}, {3.5670998108167744`*^9, 3.5670998280247583`*^9}, {
   3.5670998642888327`*^9, 3.567099881641825*^9}, {3.5670999264333873`*^9, 
   3.5670999380240498`*^9}, {3.567099975422189*^9, 3.5671000192946987`*^9}, {
   3.567100886293288*^9, 3.5671009013171473`*^9}, {3.567102145789327*^9, 
   3.567102186086632*^9}, {3.5701198334054976`*^9, 
   3.570119834773576*^9}},ExpressionUUID->"f6365403-d3d4-460e-aa13-\
5825d9b553f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate a horizontal doughnut-circle ", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.511227639104431*^9, 3.511227676201296*^9}, 3.5112278371467786`*^9, {
   3.511329767829527*^9, 
   3.5113297888739634`*^9}},ExpressionUUID->"bf307118-0971-4ea2-a091-\
7149ae271508"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myDoughnut", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"do_", ",", "di_"}], "}"}]}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "ric1", ",", "ris1", ",", "ric2", ",", "ris2", ",", "roc1", ",", 
        "ros1", ",", "roc2", ",", "ros2"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ric1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"di", " ", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         " ", 
         RowBox[{"ris1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"di", " ", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ric2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"di", " ", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", " ", 
         RowBox[{"ris2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"di", " ", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"roc1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"do", " ", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         " ", 
         RowBox[{"ros1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"do", " ", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"roc2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"do", " ", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", " ", 
         RowBox[{"ros2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"do", " ", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", "\n", "\t", 
         RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "roc1"}], ",", " ", "y", ",", " ", 
              RowBox[{"z", "+", "ros1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "ric1"}], ",", "y", ",", 
              RowBox[{"z", "+", " ", "ris1"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "ric2"}], ",", " ", "y", ",", " ", 
              RowBox[{"z", "+", "ris2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "roc2"}], ",", "y", ",", 
              RowBox[{"z", "+", " ", "ros2"}]}], "}"}]}], " ", "}"}], 
          "\[IndentingNewLine]", "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.511227639104431*^9, 
   3.511227648464447*^9}, {3.511227686902915*^9, 3.5112276902881203`*^9}, {
   3.5112277642166505`*^9, 3.511227834057973*^9}, {3.5112281336096992`*^9, 
   3.511228136370904*^9}, 3.5112282416866894`*^9, {3.5113297968299775`*^9, 
   3.5113299052813683`*^9}, {3.5671000293112717`*^9, 
   3.5671000574638815`*^9}, {3.567100282732766*^9, 3.567100284860888*^9}, {
   3.5701198393568377`*^9, 
   3.5701198404258986`*^9}},ExpressionUUID->"76445d06-325f-4553-82ec-\
41d4c7cd794c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate a horizontal circle ", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10008.},
 InitializationCell->True,
 CellChangeTimes->{{3.510921382943648*^9, 3.510921387030855*^9}, {
   3.5109214752178097`*^9, 3.51092147532701*^9}, 3.5109216634340696`*^9, {
   3.510995793279213*^9, 3.5109958004526234`*^9}, {3.5111508019808025`*^9, 
   3.511150821122036*^9}, {3.5111514464335346`*^9, 3.511151450130741*^9}, {
   3.511227639104431*^9, 3.511227676201296*^9}, 3.5112278371467786`*^9, {
   3.511329767829527*^9, 3.5113297888739634`*^9}, {3.511406401238654*^9, 
   3.511406408196266*^9}},ExpressionUUID->"5f36c7e8-07d1-4aa4-8dc4-\
4f25ee6a69c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"shp$myCircle", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], ",", 
      RowBox[{"{", "d_", "}"}]}], "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rc1", ",", "rs1", ",", "rc2", ",", "rs2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"rc1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"d", "*", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         " ", 
         RowBox[{"rs1", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"d", "*", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{"i", "/", "20"}]}], "]"}], "/", "2"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rc2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"d", "*", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", " ", 
         RowBox[{"rs2", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"d", "*", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{"2", "Pi", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}], "/", "20"}]}], "]"}], "/", 
             "2"}]}], "]"}]}], ";", "\n", "\t", 
         RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "rc1"}], ",", " ", "y", ",", " ", 
              RowBox[{"z", "+", "rs1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", "+", "rc2"}], ",", "y", ",", 
              RowBox[{"z", "+", " ", "rs2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", " ", "y", ",", " ", "z"}], "}"}]}], "}"}], 
          "\[IndentingNewLine]", "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "20"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10008.},
 InitializationCell->True,
 CellChangeTimes->{{3.5108261379627867`*^9, 3.5108261678056393`*^9}, {
   3.5108265458255033`*^9, 3.510826671358924*^9}, {3.5108267452406535`*^9, 
   3.510826767564293*^9}, {3.5108267982183466`*^9, 3.5108270238571424`*^9}, {
   3.510827061546809*^9, 3.5108270627636113`*^9}, {3.5108285860594864`*^9, 
   3.51082864504319*^9}, {3.510828758236989*^9, 3.510828761481795*^9}, {
   3.5108287926506495`*^9, 3.510828830511916*^9}, {3.5108289289480886`*^9, 
   3.5108290210194507`*^9}, {3.5109209707597237`*^9, 3.510920970931324*^9}, {
   3.510921408839693*^9, 3.5109214097288947`*^9}, 3.510921478759016*^9, 
   3.5109216634350696`*^9, {3.510995858409938*^9, 3.5109958706206365`*^9}, {
   3.5109976492029595`*^9, 3.5109976528377657`*^9}, {3.5109978226284637`*^9, 
   3.510997822924865*^9}, {3.5110750325750065`*^9, 3.511075033791809*^9}, {
   3.511075088563505*^9, 3.511075089078306*^9}, {3.5111508019808025`*^9, 
   3.511150825287244*^9}, {3.511150858983303*^9, 3.5111508859401503`*^9}, {
   3.511151748699665*^9, 3.511151749495267*^9}, {3.511227639104431*^9, 
   3.511227648464447*^9}, {3.511227686902915*^9, 3.5112276902881203`*^9}, {
   3.5112277642166505`*^9, 3.511227834057973*^9}, {3.5112281336096992`*^9, 
   3.511228136370904*^9}, 3.5112282416866894`*^9, {3.5113297968299775`*^9, 
   3.5113299052813683`*^9}, {3.511406401238654*^9, 3.5114064935284157`*^9}, {
   3.5114065865669794`*^9, 3.511406601979807*^9}, {3.5671000697315836`*^9, 
   3.567100087489599*^9}, {3.5671002904432077`*^9, 3.5671002924493217`*^9}, {
   3.5701198465012465`*^9, 
   3.5701198474703016`*^9}},ExpressionUUID->"0d81b02c-1f90-4899-a40f-\
c2c426f9d269"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create 3D shapes", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567099102884283*^9, 3.567099110037692*^9}, {
   3.5670992402151375`*^9, 3.56709925476797*^9}, 3.5701196131338987`*^9, 
   3.570119966097087*^9},ExpressionUUID->"e6c5cdff-3b2f-43f1-abf5-\
3647b130e529"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$Create3DShape", "[", 
    RowBox[{"r0_", ",", "shp_", ",", "dim_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"shp", "\[Equal]", "\"\<Cuboid\>\""}], ",", 
     RowBox[{"shp$myCuboid", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<OpenCuboid[y]\>\""}], ",", 
     RowBox[{"shp$myOpenCuboid", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<ClosedCylinder\>\""}], ",", 
     RowBox[{"shp$myClosedCylinder", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "5"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<OpenCylinder[x]\>\""}], ",", 
     RowBox[{"shp$myCylinderX", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<OpenCylinder[y]\>\""}], ",", 
     RowBox[{"shp$myCylinderY", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<OpenCylinder[z]\>\""}], ",", 
     RowBox[{"shp$myCylinderZ", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<TruncatedCone[y]\>\""}], ",", 
     RowBox[{"shp$myTruncatedCone", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<DoubleCylinder[y]\>\""}], ",", 
     RowBox[{"shp$myDoubleCylinder", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "5"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<Doughnut[y]\>\""}], ",", 
     RowBox[{"shp$myDoughnut", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"shp", "\[Equal]", "\"\<Circle[y]\>\""}], ",", 
     RowBox[{"shp$myCircle", "[", 
      RowBox[{"r0", ",", 
       RowBox[{"dim", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "1"}], "]"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5670991129788604`*^9, 3.56709914532271*^9}, {
   3.5670991824098315`*^9, 3.5670994584046173`*^9}, {3.567100100357335*^9, 
   3.5671001871372986`*^9}, {3.5671002327669086`*^9, 
   3.5671003436832523`*^9}, {3.5701198537466607`*^9, 3.570119874294836*^9}, {
   3.916276510137253*^9, 3.916276516033023*^9}, {3.91627707838945*^9, 
   3.9162770805028577`*^9}, {3.916277225111264*^9, 3.9162772283516607`*^9}, {
   3.916277643017691*^9, 3.916277751847537*^9}, 
   3.9162778978864737`*^9},ExpressionUUID->"c6681b39-9e9f-4d45-914c-\
0105f0cddf8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$Create3DShape", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<mod$Create3DShape[r0, shp,dim] generates 3D graphics with given shape \
'shp' and corresponding dimension 'dim' at the position vector 'r0'. The \
shape should be chose from list$BodyShape.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571490000702132*^9, 
  3.571490091703337*^9}},ExpressionUUID->"5b161415-6cca-44b8-be88-\
c02cc54e60dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Body Shape List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567054972779853*^9, 3.567054976693077*^9}, {
  3.567055022497697*^9, 3.567055048023157*^9}, {3.5670553367586718`*^9, 
  3.5670553505304594`*^9}, {3.5670554993419704`*^9, 3.567055508455492*^9}, {
  3.5670555953084598`*^9, 3.5670555993806925`*^9}, {3.5670558599685974`*^9, 
  3.5670558686600947`*^9}, {3.5670569156809807`*^9, 3.567056916226012*^9}, {
  3.5670904312602944`*^9, 3.567090450002366*^9}, {3.5670914472764072`*^9, 
  3.5670914479104433`*^9}, {3.567268082722387*^9, 
  3.5672680857785616`*^9}},ExpressionUUID->"af9d9939-e5b8-4e78-ab36-\
541dbd972f7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"list$BodyShape", "=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
     "\"\<Cuboid\>\"", ",", "\[IndentingNewLine]", "\"\<OpenCuboid[y]\>\"", 
      ",", "\[IndentingNewLine]", "\"\<ClosedCylinder\>\"", ",", 
      "\[IndentingNewLine]", "\"\<OpenCylinder[x]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<OpenCylinder[y]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<OpenCylinder[z]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<TruncatedCone[y]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<DoubleCylinder[y]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Doughnut[y]\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Circle[y]\>\""}], "\[IndentingNewLine]", 
     "}"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5670918678854647`*^9, 3.5670918908747797`*^9}, {
  3.567091923527647*^9, 3.5670921255532026`*^9}, {3.567092319494295*^9, 
  3.567092862147333*^9}, {3.56709439032374*^9, 3.5670944579656086`*^9}, {
  3.567096515239278*^9, 3.5670965326282725`*^9}, {3.567097401107947*^9, 
  3.5670974134586535`*^9}, {3.5670975342395616`*^9, 3.5670975753089104`*^9}, {
  3.5670984111447177`*^9, 3.5670984117047496`*^9}, {3.5670984475097976`*^9, 
  3.5670984723722196`*^9}, {3.567101919358376*^9, 3.567101958986643*^9}, {
  3.5671023543612566`*^9, 3.5671023565593824`*^9}, {3.5701200316928387`*^9, 
  3.5701200540081153`*^9}, {3.5701201037609606`*^9, 3.570120109779305*^9}, {
  3.9162765220241585`*^9, 3.9162765250168962`*^9}, {3.9162776066414723`*^9, 
  3.9162776344440885`*^9}},ExpressionUUID->"aa53212d-b367-41f7-9616-\
9ca2eb806cb5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"list$ShapeDimNote", "[", "shp_", "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"shp", "\[Equal]", "\"\<Cuboid\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<X-Size\>\"", ",", "\"\<Y-Size\>\"", ",", "\"\<Z-Size\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<OpenCuboid[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<X-Size\>\"", ",", "\"\<Y-Size\>\"", ",", "\"\<Z-Size\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<ClosedCylinder\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Diameter\>\"", ",", "\"\<Length\>\"", ",", "\"\<X-Orient\>\"", 
        ",", "\"\<Y-Orient\>\"", ",", "\"\<Z-Orient\>\""}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<Cylinder[x]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Diameter\>\"", ",", "\"\<Length\>\"", ",", "\"\<\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<Cylinder[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Diameter\>\"", ",", "\"\<Height\>\"", ",", "\"\<\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<Cylinder[z]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Diameter\>\"", ",", "\"\<Length\>\"", ",", "\"\<\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<TruncatedCone[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Upper D\>\"", ",", "\"\<Lower D\>\"", ",", "\"\<Height\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<DoubleCylinder[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Upper D\>\"", ",", "\"\<Lower D\>\"", ",", "\"\<Upper H\>\"", 
        ",", "\"\<Lower H\>\"", ",", "\"\<CoM Height\>\""}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<Doughnut[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Outer D\>\"", ",", " ", "\"\<Inner D\>\"", ",", "\"\<\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"shp", "\[Equal]", "\"\<Circle[y]\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Diameter\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", 
        ",", "\"\<\>\""}], "}"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5701200605864916`*^9, 3.5701840373962383`*^9, {3.9162765431371546`*^9, 
   3.9162765703605294`*^9}, {3.916277756857424*^9, 3.916277809561227*^9}, {
   3.9162778813599796`*^9, 
   3.9162778945707464`*^9}},ExpressionUUID->"e70a2152-d97a-4c26-8390-\
11dec02d2226"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1430.25, 743.625},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"13.1 for Microsoft Windows (64-bit) (August 22, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"5abdde88-aa53-4b65-b8d0-1f34b4dc26f4"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 265, 9, 60, "Subtitle",ExpressionUUID->"7cdc2b97-d9d4-4461-90ec-a05a0f1b46d2",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[857, 35, 180, 4, 33, "Section",ExpressionUUID->"42bc0147-c2f8-4293-b696-9de57ea7d513",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1062, 43, 251, 5, 23, "Subsubsection",ExpressionUUID->"1bdcabe1-ce5d-444b-bb42-718332cee99c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1338, 52, 453, 8, 19, "Text",ExpressionUUID->"ba541816-2a95-48b3-b756-5a46843e8002",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[1794, 62, 8993, 238, 402, "Input",ExpressionUUID->"c97a2db6-efac-416f-ae1a-ed1f420c8650",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[10824, 305, 337, 6, 19, "Text",ExpressionUUID->"42410490-7eb4-4554-8d00-d34c3a2d6dd6",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True],
Cell[11164, 313, 6246, 165, 285, "Input",ExpressionUUID->"9fedae6f-5bbe-4607-84b6-0452eb28fdf1",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[17447, 483, 576, 9, 19, "Text",ExpressionUUID->"dcdff543-fc59-42ac-962e-1e8ca59988db",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True],
Cell[18026, 494, 3460, 73, 81, "Input",ExpressionUUID->"017cf960-9297-4d43-94c0-86cfd45c8757",
 CellGroupingRules->{"GroupTogetherGrouping", 10005.},
 InitializationCell->True],
Cell[21489, 569, 588, 9, 19, "Text",ExpressionUUID->"cc6a6b6d-898b-4a18-92fe-89577d1c3ff0",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True],
Cell[22080, 580, 5155, 119, 139, "Input",ExpressionUUID->"afbacabd-baae-41f3-90b8-4fcbc753fae0",
 CellGroupingRules->{"GroupTogetherGrouping", 10005.},
 InitializationCell->True],
Cell[27238, 701, 488, 8, 19, "Text",ExpressionUUID->"8d85ba5d-4778-4a33-9a67-fb054c9f7ae6",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True],
Cell[27729, 711, 5057, 117, 139, "Input",ExpressionUUID->"1e6f8192-dd92-496f-abbc-083c354bc84e",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[32823, 833, 488, 8, 19, "Text",ExpressionUUID->"5ce5f857-7140-4107-9864-a807e7806106",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True],
Cell[33314, 843, 5259, 120, 139, "Input",ExpressionUUID->"371e64b6-ab06-405a-98f5-b1b9b38f9bdb",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[38610, 968, 568, 9, 19, "Text",ExpressionUUID->"689d6318-543f-403b-9a0a-7207ad863635",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True],
Cell[39181, 979, 6757, 158, 158, "Input",ExpressionUUID->"2f59a05b-d63c-42ae-afa8-4d9e70cd4dfb",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[45975, 1142, 549, 9, 19, "Text",ExpressionUUID->"2d127797-f7fe-41a9-86f8-1a258aadf00e",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True],
Cell[46527, 1153, 8900, 199, 246, "Input",ExpressionUUID->"f6365403-d3d4-460e-aa13-5825d9b553f6",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[55464, 1357, 614, 10, 19, "Text",ExpressionUUID->"bf307118-0971-4ea2-a091-7149ae271508",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True],
Cell[56081, 1369, 5916, 139, 148, "Input",ExpressionUUID->"76445d06-325f-4553-82ec-41d4c7cd794c",
 CellGroupingRules->{GroupTogetherGrouping, 10007.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[62034, 1513, 651, 10, 19, "Text",ExpressionUUID->"5f36c7e8-07d1-4aa4-8dc4-4f25ee6a69c5",
 CellGroupingRules->{GroupTogetherGrouping, 10008.},
 InitializationCell->True],
Cell[62688, 1525, 4287, 94, 119, "Input",ExpressionUUID->"0d81b02c-1f90-4899-a40f-c2c426f9d269",
 CellGroupingRules->{GroupTogetherGrouping, 10008.},
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[67024, 1625, 292, 5, 23, "Subsubsection",ExpressionUUID->"e6c5cdff-3b2f-43f1-abf5-3647b130e529",
 InitializationCell->True],
Cell[67319, 1632, 3558, 87, 142, "Input",ExpressionUUID->"c6681b39-9e9f-4d45-914c-0105f0cddf8d",
 InitializationCell->True],
Cell[70880, 1721, 488, 10, 33, "Input",ExpressionUUID->"5b161415-6cca-44b8-be88-c02cc54e60dc",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[71405, 1736, 649, 10, 23, "Subsubsection",ExpressionUUID->"af9d9939-e5b8-4e78-ab36-541dbd972f7b",
 InitializationCell->True],
Cell[72057, 1748, 1635, 28, 141, "Input",ExpressionUUID->"aa53212d-b367-41f7-9616-9ca2eb806cb5",
 InitializationCell->True],
Cell[73695, 1778, 3397, 76, 240, "Input",ExpressionUUID->"e70a2152-d97a-4c26-8390-11dec02d2226",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

